
; ========================================================
;			
;    -- Sounder.inc --
;			Jay Sullivan
; ========================================================
  
;#################################################
;#                Macro
;#################################################

  

	; OPATTR() macro
	  OP_ATTR_MEMORY    equ 1
	  OP_ATTR_IMMEDIATE equ 2
	  OP_ATTR_MEMDIRECT equ 3
	  OP_ATTR_REGISTER  equ 4
	  OP_ATTR_DEFINED   equ 5
	  OP_ATTR_SEGMENTSS equ 6
	  OP_ATTR_EXTERNAL  equ 7

	RoundingMode MACRO Bits
	LOCAL ttemp
		.data?
		 ttemp dw ?
		.code
			fstcw ttemp
			and ttemp, 0F0FFh      ;; Clears bits 8-11.
			or ttemp,  00&Bits&00000000b      ;; Rounding control=%11, Precision = %00.
			fldcw ttemp
	ENDM

	$String MACRO sTEXT
		LOCAL szText
		.data
		 szText db sTEXT, 0
		.code
		EXITM <Offset szText>
	ENDM
	
	
	$Const MACRO Num
		result textequ @CatStr(<c_>,<%Num>)
	% IFNDEF result
		  .const 
		    result dd Num
		  .code
	  ENDIF
		EXITM <result>
	ENDM
	
	$ConstEx MACRO Num, numType
		result textequ @CatStr(<c_>,<%Num>)
	% IFNDEF result
		  .const 
		    result &numType& Num
		  .code
	  ENDIF
		EXITM <result>
	ENDM
	
	

;#################################################
;#                Include
;#################################################
	include windows.inc
	include user32.inc
	include kernel32.inc
	include gdi32.inc
	include winmm.inc
	;-------------------------------------------------------------------
	;Needed For Debug Window Only
	;include masm32.inc
	;include debug.inc
	;includeLib masm32.lib
	;includeLib debug.lib
	;-------------------------------------------------------------------
	includeLib user32.lib
	includeLib kernel32.lib
	includelib gdi32.lib
	includelib winmm.lib

;#################################################
;#                .DATA
;#################################################



	.DATA
	ClassName		db "MainWinClass",0
	CFret_ClassName db 'CFret',0
	szAppName		db "Sounder",0
	szCButton		db "BUTTON",0
	szWheel db 'AaBCcDdEFfGg',0


	NoteChooserX	dd 6 dup(121)
	NoteChooserY	dd 128+34*0,
	                   127+34*1,
	                   126+34*2,
	                   126+34*3,
	                   124+34*4,
	                   123+34*5
	

	.DATA?
	hInstance		HINSTANCE ?
	CommandLine		LPSTR ?
	
	dumpBuffer db 100 dup(?)
;#################################################
;#                .BUTTONS
;#################################################

	hButtonClear HWND ?
	q =0
	for myChar,<E,F,FS,G,GS,A>
		hButton&myChar&  HWND ?
	q = q + 1
	endm
	
;#################################################
;#              WM_PAINT variables
;#################################################
	g_hbmGuitar		HBITMAP ?
	g_hbmNote		HBITMAP ?
	
hMenu			HMENU ?
		bm				BITMAP <>
		ps				PAINTSTRUCT <>
		hdc				HDC ?
		hdcMem			HDC ?
		hdcShade HDC ?
		hbmOld			HBITMAP ?
		hwnd			HWND	?
		hHeap 			DWORD ?
		
	 ; Note bitmap coordinates
	 ; X= 0   + 8 + 113*x
	 ; Y= 120 + 8 + 34*y
	
;#################################################
;#              MULTIMEDIA
;#################################################
		;invoke PlaySound,2006,0,SND_RESOURCE 

	MaxSoundSize	equ  4096   ; 4k sound buffer
	 
	wf_wFormatTag 		equ  WAVE_FORMAT_PCM
	wf_nChannels 		equ  1; 2 channels format: <SampleLeft, SampleRight>
	wf_nSamplesPerSec	equ  44100;44100
	wf_wBitsPerSample	equ  16
	wf_nBlockAlign		equ  wf_nChannels * wf_wBitsPerSample / 8
	wf_nAvgBytesPerSec	equ  wf_nSamplesPerSec * wf_nBlockAlign
	wf_cbSize			equ  0
			
	; fullsinwave = 88200 / frequency


;------------------------------------------------
;	Wave format
;------------------------------------------------
	.data
		ThreadSignalInfo STRUCT
			hThread  HANDLE ?
			fDONE	HANDLE ?
			TIME  DWORD	 ?
			FREQ  REAL4 ?
		ThreadSignalInfo ENDS
		
	
		String0 ThreadSignalInfo <0,0,1000,?>
		String1 ThreadSignalInfo <0,0,1000,?>
		String2 ThreadSignalInfo <0,0,1000,?>
		String3 ThreadSignalInfo <0,0,1000,?>
		String4 ThreadSignalInfo <0,0,1000,?>
		String5 ThreadSignalInfo <0,0,1000,?>
		
        StringIndex0 dd 0
        StringIndex1 dd 0
        StringIndex2 dd 0
        StringIndex3 dd 0
        StringIndex4 dd 0
        StringIndex5 dd 0
        
        
        
        
        
                                                                                       ;    freq = (440 * 12 ^(1/n) ) | n = ...

					 ; fret =   |      0       |     1       |       2       |        3      |       4       |       5       |
		;FrequencyTable  real4	329.62755691287,349.22823143300,369.99442271163,391.99543598175,415.30469757994,440.00000000000 ; String0 (-5, -4, -3, -2, -1, 0  )
		;				real4	246.94165062806,261.62556530060,277.18263097687,293.66476791741,311.12698372208,329.62755691287 ; String1 (-10,-9, -8, -7, -6, -5 )
		;				real4	195.99771799087,207.65234878998,220.00000000000,233.08188075905,246.94165062806,261.62556530060 ; String1 (-14,-13,-12,-11,-10,-9 )
		;				real4	146.83238395871,155.56349186104,164.81377845643,174.61411571651,184.99721135582,195.99771799087 ; String2 (-19,-18,-17,-16,-15,-14)
		;				real4	110.00000000000,116.54094037952,123.47082531403,130.81278265030,138.59131548843,146.83238395871 ; String3 (-24,-23,-22,-21,-20,-19)
		;				real4	82.406889228215,87.307057858253,92.498605677909,97.998858995435,110.00000000000,105.82617439499 ; String4 (-29,-28,-27,-26,-25,-24)

		

;			       X001		X002		X003		X004		X005		X006
FrequencyTable	real4	82.406889228215,87.307057858253,92.498605677909,97.998858995435,105.82617439499,110.00000000000 ; String4 (-29,-28,-27,-26,-25,-24)
				real4	110.00000000000,116.54094037952,123.47082531403,130.81278265030,138.59131548843,146.83238395871 ; String3 (-24,-23,-22,-21,-20,-19)
				real4	146.83238395871,155.56349186104,164.81377845643,174.61411571651,184.99721135582,195.99771799087 ; String2 (-19,-18,-17,-16,-15,-14)
				real4	195.99771799087,207.65234878998,220.00000000000,233.08188075905,246.94165062806,261.62556530060 ; String1 (-14,-13,-12,-11,-10,-9 )
				real4	246.94165062806,261.62556530060,277.18263097687,293.66476791741,311.12698372208,329.62755691287 ; String1 (-10,-9, -8, -7, -6, -5 )
				real4	329.62755691287,349.22823143300,369.99442271163,391.99543598175,415.30469757994,440.00000000000 ; String0 (-5, -4, -3, -2, -1, 0  )

		WaveFormat WAVEFORMATEX <wf_wFormatTag, wf_nChannels, wf_nSamplesPerSec, wf_nAvgBytesPerSec, wf_nBlockAlign, wf_wBitsPerSample, wf_cbSize >
    ;WaveHeader WAVEHDR     <Offset SoundBuffer, 0, 0,0,WHDR_BEGINLOOP or WHDR_ENDLOOP ,1000 >

	 ;.data?
	 ;align 16
	 ;SoundBuffer db MaxSoundSize dup (?);  // Sound data buffer

;#################################################
;#                EQU
;#################################################
bmpGuitar		EQU 204
bmpNote		EQU 205
IDM_MNU		EQU 999
IDM_Note_Clear	EQU 3998

IDM_Note_5		EQU 3999
IDM_Note_5_82		EQU 4000
IDM_Note_5_87		EQU 4001
IDM_Note_5_92		EQU 4002
IDM_Note_5_97		EQU 4003
IDM_Note_5_105		EQU 4004
IDM_Note_5_110		EQU 4005
IDM_Note_4		EQU 4015
IDM_Note_4_110		EQU 4016
IDM_Note_4_116		EQU 4017
IDM_Note_4_123		EQU 4018
IDM_Note_4_130		EQU 4019
IDM_Note_4_138		EQU 4020
IDM_Note_4_146		EQU 4021
IDM_Note_3		EQU 4031
IDM_Note_3_146		EQU 4032
IDM_Note_3_155		EQU 4033
IDM_Note_3_164		EQU 4034
IDM_Note_3_174		EQU 4035
IDM_Note_3_184		EQU 4036
IDM_Note_3_195		EQU 4037
IDM_Note_2		EQU 4047
IDM_Note_2_195		EQU 4048
IDM_Note_2_207		EQU 4049
IDM_Note_2_220		EQU 4050
IDM_Note_2_233		EQU 4051
IDM_Note_2_236		EQU 4052
IDM_Note_2_261		EQU 4053
IDM_Note_1		EQU 4063
IDM_Note_1_246		EQU 4064
IDM_Note_1_261		EQU 4065
IDM_Note_1_277		EQU 4066
IDM_Note_1_293		EQU 4067
IDM_Note_1_311		EQU 4068
IDM_Note_1_329		EQU 4069
IDM_Note_0		EQU 4079
IDM_Note_0_329		EQU 4080
IDM_Note_0_349		EQU 4081
IDM_Note_0_369		EQU 4082
IDM_Note_0_391		EQU 4083
IDM_Note_0_415		EQU 4084
IDM_Note_0_440		EQU 4085



WM_SETSTATE equ WM_USER+10h
